%global pkg slime

Name:            emacs-%{pkg}
Epoch:           1
Version:         2.12
Release:         5%{?dist}
Summary:         The superior lisp interaction mode for emacs        

Group:           Applications/Editors
#Public domain: Mentioned in README file
#LLGPL: Mentioned in swank-ccl.lisp
#GPLv2+: slime.el,slime-autoloads.el
#GPLv3+: Many files in contrib are GPLv3+
License:         Public Domain and GPLv3+ and GPLv2+ and LLGPL
URL:             http://common-lisp.net/project/slime/
Source0:         https://github.com/slime/slime/archive/v%{version}.tar.gz
Patch1:          swank_changelog_plus_location.patch

BuildRequires:   emacs texinfo common-lisp-controller
# for testing
BuildRequires:   sbcl
Requires:        emacs(bin) >= %{_emacs_version} common-lisp-controller

Requires(post):  info common-lisp-controller
Requires(preun): info common-lisp-controller

BuildArch:      noarch

%description
SLIME is a Emacs mode for common Lisp development.

%package el
Summary:        Elisp source files for %{name}
Group:          Applications/Editors
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description el
This package contains the Elisp source files for %{name}. You do not need
to install this package to use %{name}.

%prep
%setup -q -n %{pkg}-%{version}
%patch1 -p1

%build
#{_emacs_bytecompile} *.el
make
cd doc/
make slime.info

%install
install -pm 755 -d %{buildroot}%{_emacs_sitestartdir}
install -pm 644 *.el  %{buildroot}%{_emacs_sitestartdir}

install -pm 755 -d %{buildroot}%{_infodir}
install -pm 644 doc/%{pkg}.info %{buildroot}%{_infodir}/

install -pm 755 -d %{buildroot}%{_emacs_sitelispdir}/%{pkg}
install -pm 755 -d %{buildroot}%{_emacs_sitelispdir}/%{pkg}/contrib
install -pm 755 -d %{buildroot}%{_emacs_sitelispdir}/%{pkg}/lib
install -pm 644 *.el* %{buildroot}%{_emacs_sitelispdir}/%{pkg}/
install -pm 644 lib/*.el* %{buildroot}%{_emacs_sitelispdir}/%{pkg}/lib/


install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime
install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime/lib
install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime/swank
install -pm 644 *.lisp %{buildroot}%{_datadir}/common-lisp/source/slime
install -pm 644 contrib/*.lisp %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/*.el %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/README.md %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/ChangeLog %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 lib/*.el %{buildroot}%{_datadir}/common-lisp/source/slime/lib
install -pm 644 swank/*.lisp %{buildroot}%{_datadir}/common-lisp/source/slime/swank
install -pm 644 *.asd %{buildroot}%{_datadir}/common-lisp/source/slime

mv contrib/README.md contrib/contrib-README.md
mv contrib/ChangeLog contrib/contrib-ChangeLog

%check
make check

%post
/sbin/install-info %{_infodir}/%{pkg}.info %{_infodir}/dir || :
/usr/sbin/register-common-lisp-source swank

%preun
if [ "$1" = 0 ]; then
 /sbin/install-info --delete %{_infodir}/%{pkg}.info %{_infodir}/dir || :
fi
/usr/sbin/unregister-common-lisp-source swank 

%files
%defattr(-,root,root,-)
%doc ChangeLog NEWS PROBLEMS README.md doc/slime-small.pdf doc/slime-refcard.pdf contrib/contrib-README.md contrib/contrib-ChangeLog

%dir %{_emacs_sitestartdir}
%{_emacs_sitestartdir}/*.el

%dir %{_emacs_sitelispdir}/%{pkg}
%dir %{_emacs_sitelispdir}/%{pkg}/contrib
%dir %{_emacs_sitelispdir}/%{pkg}/lib
%{_emacs_sitelispdir}/%{pkg}/*.elc
%{_emacs_sitelispdir}/%{pkg}/lib/*.elc

%dir %{_datadir}/common-lisp/source/slime
%dir %{_datadir}/common-lisp/source/slime/contrib
%dir %{_datadir}/common-lisp/source/slime/lib
%{_datadir}/common-lisp/source/slime/*.lisp
%{_datadir}/common-lisp/source/slime/contrib/*.lisp
%{_datadir}/common-lisp/source/slime/contrib/*.el
%{_datadir}/common-lisp/source/slime/lib/*.el
%{_datadir}/common-lisp/source/slime/swank/*.lisp
%{_datadir}/common-lisp/source/slime/contrib/README.md
%{_datadir}/common-lisp/source/slime/contrib/ChangeLog
%{_datadir}/common-lisp/source/slime/*.asd
%{_infodir}/%{pkg}.info.gz

%files el
%defattr(-,root,root,-)
%doc CONTRIBUTING.md
%{_emacs_sitelispdir}/%{pkg}/*.el
%{_emacs_sitelispdir}/%{pkg}/lib/*.el

%changelog
* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1:2.12-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1:2.12-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Jan 16 2016 Benjamin Kreuter <ben.kreuter@gmail.com> - 1:2.12-4
- Fixed spec file to install swank.

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:2.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Feb 19 2015 Michel Alexandre Salim <salimma@fedoraproject.org> - 1:2.12-2
- Add Epoch to subpackage's dependency

* Mon Feb 16 2015 Michel Alexandre Salim <salimma@fedoraproject.org> - 1:2.12-1
- Update to latest stable release
- Spec clean-ups

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.10.20120525cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.9.20120525cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.8.20120525cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 25 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.7.20120525cvs
- Hardcode location of slime-backend
- Renamed patches
- Removed known_implementations.patch. Otherwise inferior-lisp-program variable is not used by slime.

* Mon Jul 23 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.6.20120525cvs
- All .el files go into -el package except for those under contrib. They go into common-lisp/source/slime
- Copy readme and changelog into contrib folder. Gives an idea of how to load the definitions into emacs.
- Rename readme and changelog under contrib and put them into doc folder as well.

* Mon Jul 23 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.5.20120525cvs
- Apply patches to fix slime load error.
- Copy contrib directory in both base and el packages.

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.4.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.3.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.2.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Nov 14 2010 Arun SAG <sagarun at gmail dot com> - 3.0-0.1.20101113cvs
- Fixed the version information
- Fixed the license information
- Removed the buildroot tag as it is obsolete

* Sat Sep 11 2010 Arun SAG <sagarun at gmail dot com> - 1.2-1
- Initial release
